package com.faraphel.tasks_valider.database.dao

import androidx.room.Dao
import androidx.room.Query
import androidx.room.RewriteQueriesToDropUnusedColumns
import com.faraphel.tasks_valider.database.dao.base.BaseDao
import com.faraphel.tasks_valider.database.entities.Group
import com.faraphel.tasks_valider.database.entities.Task


@Dao
interface TaskDao : BaseDao<Task> {
    @Query("SELECT * FROM `tasks`")
    override fun getAll(): List<Task>

    @Query("SELECT * FROM `tasks` WHERE id = :id")
    fun getById(id: Long): Task

    /**
    Get all the tasks for a specific group
     */
    @Query(
        "SELECT * FROM `tasks` " +
        "JOIN `task_group` ON `tasks`.id = `task_group`.task_id " +
        "WHERE `task_group`.group_id = :groupId"
    )
    @RewriteQueriesToDropUnusedColumns
    fun filterByGroupId(groupId: Long): List<Task>
}
