package com.faraphel.tasks_valider.ui.screen.room

import android.net.wifi.p2p.WifiP2pDeviceList
import android.net.wifi.p2p.WifiP2pManager
import androidx.compose.foundation.layout.Column
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.remember
import com.faraphel.tasks_valider.connectivity.wifi_p2p.WifiP2pHelper
import com.faraphel.tasks_valider.ui.widgets.connectivity.WifiP2pDeviceListWidget


/**
 * This screen allow the user to join a room
 */
@Composable
fun RoomClientScreen(wifiP2pHelper: WifiP2pHelper) {
    val peers = remember { mutableStateOf<WifiP2pDeviceList?>(null) }

    Column {
        Text(text = "Find a Server")
        WifiP2pDeviceListWidget(peers.value)
    }

    // TODO(Faraphel): might be doubtful. Test with more phones, should it only run once ? refresh button ?
    wifiP2pHelper.registerListener(
        WifiP2pManager.WIFI_P2P_PEERS_CHANGED_ACTION,
        { new_peers: WifiP2pDeviceList? -> peers.value = new_peers },
        once = true
    )
    wifiP2pHelper.discoverPeers()
}