package com.faraphel.tasks_valider.ui.widgets.connectivity

import android.net.wifi.p2p.WifiP2pDeviceList
import androidx.compose.foundation.layout.Column
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable


/**
 * Represent a list of WiFi-Direct devices.
 */
@Composable
fun WifiP2pDeviceListWidget(peers: WifiP2pDeviceList?) {
    Text(text = "Devices (${peers?.deviceList?.size ?: 0})")

    Column {
        if (peers != null) {
            for (device in peers.deviceList) {
                WifiP2pDeviceWidget(device)
            }
        }
    }
}